//HDL Example 6-1
//--------------------- 
//Behavioral description of 
//Universal shift register
// Fig. 6-7 and Table 6-3
module shftreg (s1,s0,Pin,lfin,rtin,A,CLK,Clr);
   input s1,s0;                     //Select inputs
   input lfin, rtin;                //Serial inputs      
   input CLK,Clr;                   //Clock and Clear
   input [3:0] Pin;                 //Parallel input
   output [3:0] A;                  //Register output
   reg [3:0] A;
   always @ (posedge CLK or negedge Clr)
     if (~Clr) A = 4'b0000;
      else
        case ({s1,s0})
         2'b00: A = A;              //No change
         2'b01: A = {rtin,A[3:1]};  //Shift right
         2'b10: A = {A[2:0],lfin};  //Shift left
         2'b11: A = Pin;            //Parallel load input
        endcase
endmodule

