//HDL Example 6-3
//-------------------   
//Binary counter with parallel load
//See Figure 6-14 and Table 6-6
module counter (Count,Load,IN,CLK,Clr,A,CO);
  input Count,Load,CLK,Clr;
  input [3:0] IN;                //Data input
  output CO;                     //Output carry
  output [3:0] A;                //Data output
  reg [3:0] A;
  assign CO = Count & ~Load & (A == 4'b1111);
  always @ (posedge CLK or negedge Clr)
    if (~Clr) A = 4'b0000;
    else if (Load)  A = IN;        
    else if (Count) A = A + 1'b1;  
    else A = A;                  // no change, default condition 
endmodule

